---
# Official language image. Look for the different tagged releases at:
# https://hub.docker.com/r/library/python/tags/
image: python:latest

# Change pip's cache directory to be inside the project directory since we can
# only cache local items.
variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

# Pip's cache doesn't store the python packages
# https://pip.pypa.io/en/stable/reference/pip_install/#caching
#
# If you want to also cache the installed packages, you have to install
# them in a virtualenv and cache it as well.
cache:
  paths:
    - .cache/pip
    - venv/

before_script:
  - python -V  # Print out python version for debugging
  - pip install twine tox flake8 codecov

codecov:
  stage: test
  script:
    - tox -e coverage
    - codecov

linting:
  stage: test
  script:
    - tox -e black,yamllint,flake8

deploy_staging:
  stage: deploy
  variables:
    TWINE_USERNAME: $STAGING_USERNAME
    TWINE_PASSWORD: $STAGING_PASSWORD
  script:
    - python setup.py egg_info -b $(date +%s%N) bdist bdist_wheel
    - twine upload --repository-url $PYTEST_REPOSITORY_URL dist/*
  except:
    - tags

deploy_production:
  stage: deploy
  variables:
    TWINE_USERNAME: $PRODUCTION_USERNAME
    TWINE_PASSWORD: $PRODUCTION_PASSWORD
  script:
    - python setup.py bdist bdist_wheel
    - twine upload dist/*
  only:
    - tags

python36:
  image: python:3.6
  stage: test
  script: tox -e py36

python37:
  stage: test
  script: tox -e py37

python38:
  stage: test
  script: tox -e py38

python39:
  stage: test
  script: tox -e py39
...
